# !/usr/bin/perl
# file to parse hmmer output files (of the type
# produced with the settings from multiHmmering.pl
# infile is the result file, pipe output to
# architecture file

open (FH, $ARGV [0]);

$mode = 0;

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 if ($aLine =~ /Query sequence: ([^\|]*)\|(\S*)/) {

  $ac = $1;
  $id = $2;
  @doms = ();

 }

 if ($aLine =~ /Parsed for domains:/) {

  $mode = 1;

 }

 if ($aLine =~ /^(PF\d{5})/ && $mode == 1) {

  push (@doms, $1);

 }

 if ($aLine =~ /^\/\//) {

  $mode = 0;  

  $sS = "$ac $id ";

  foreach $aDomain (@doms) {

   $sS = $sS."$aDomain*";

  }

  if (@doms > 0) {

   chop ($sS);

  }

  $sS = $sS."\n";

  print "$sS";

 }

}

close (FH);