#!/usr/bin/perl
# script that reads a file (name is second input argument)
# and splits it into a number of smaller files (the original remains unchanged)
# of size at most (first input argument). New files have same name as
# the original, but with .id number at the end.
# when doing this with fasta files, use an even partition size number
# to preserve header-sequence order
# also, if necessary, cleanFasta.pl the file first to ensure
# single-line sequences

$partitionSize = $ARGV [0];
$i = 0;
$j = 0;

open (FH, $ARGV [1]);
open (FH2, ">$ARGV[1].$j");

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 print FH2 "$aLine\n";

 $i++;

 if ($i % $partitionSize == 0) {

  close (FH2);
  $j++;
  open (FH2, ">$ARGV[1].$j");

 }

}

close (FH);
close (FH2);