# !/usr/bin/perl
# runOnCluster.pl
# wrapper for scripts to do hmmer (Pfam-A) domain recognition
# on a set of sequences
# this is the main file to run on the cluster
# all the paths should be set here
#
# use partitionFile.pl to divide the base fasta files
# into smaller files of perhaps 50-100 sequences each (these finish
# easily in four hours node time, you could probably go up
# to more sequences per node) of name
#
# eventually, there will be results files in the results directory
# (check that these files are all there and are all the right size, rerun with higher $nodeTime)
# until all are done
# cat together all the files into a single result file, and
# then use parseHmmerOutput.pl to parse that into an architecture list file

$noFiles = 100; # or however many fasta files you have
$fastaDirectory = "/afs/pdc.kth.se/home/k/krifo/vol04/fasta"; # absolute afs path to wherever your source files are - change this!
$resultsDirectory = "/afs/pdc.kth.se/home/k/krifo/vol04/hmmresults"; # absolute afs path to where you want the hmmer output files - change this!
$scriptDirectory = "/afs/pdc.kth.se/home/k/krifo/vol04/multiHmmering"; # where the other scripts are, probably wherever this script is - change this!
$filePrefix = "genomeflatfile.something.fasta"; # fasta files should be names $filePrefix.number where number = 0...$noFiles
$nodeTime = 239; # node time in minutes - four-hour jobs go fastest through the queue, so this is preferred
$pfamFile = "/afs/pdc.kth.se/home/k/krifo/vol04/Pfam\_ls.gz"; # absolute path to zipped Pfam_ls.gz file - change this!
$hmmerFile = "/afs/pdc.kth.se/home/e/esjolund/Public/software/hmmer/2.3.2/install/i386_fc3/bin/hmmpfam"; # absolute path to hmmer executable


for ($i = 0; $i < $noFiles; $i++) {

 # if a previous run already fixed this file, do not rerun it

 if (! (-s "$resultsDirectory/$filePrefix.$i.result")) {
 
  print "Starting hmmpfam run for $fastaDirectory/$filePrefix.$i\n";

  system ("esubmit -n 1 -m -t $nodeTime perl $scriptDirectory/multiHmmering.pl $filePrefix.$i $fastaDirectory $resultsDirectory $pfamFile $hmmerFile")

 }

}